/* mem-misc.c */

/* fonctions diverses */

int verb_gc;

extern char * itoa();

#ifdef DEBUG
static char msg1 [] = "Assertion failed (please report it) : ";
static char msg2 [] = "; file : ";
static char msg3 [] = "; line : ";
static char msg4 [] = "\n";

void failed_assert (expr, file, line)
     char *expr, *file;
     unsigned long line;
{
  char buff [13];
  char *slin = itoa (buff, line);

  write (2, msg1, sizeof (msg1) - 1);
  write (2, expr, strlen (expr));
  write (2, msg2, sizeof (msg2) - 1);
  write (2, file, strlen (file));
  write (2, msg3, sizeof (msg3) - 1);
  write (2, slin, strlen (slin));
  write (2, msg4, sizeof (msg4) - 1);
  exit(100);
}
#endif /* DEBUG */

void gc_message (str1, num, str2)
     char *str1, *str2;
     unsigned long num;
{
  char buff [13];
  char *snum = itoa (buff, num);

  if (verb_gc){
    write (2, str1, strlen (str1));
    write (2, snum, strlen (snum));
    write (2, str2, strlen (str2));
  }
}

void gc_message_str (s)
     char *s;
{
  if (verb_gc){
    write (2, s, strlen (s));
  }
}

void fatal_error (s)
     char *s;
{
  write (2, "fatal error : ", 14);
  write (2, s, strlen (s));
  write (2, "\n", 1);
  exit(2);
}

extern int errno;
extern char * error_message();

void fatal_unix_error (s1, s2)
     char * s1, * s2;
{
  char * s;
  write(2, s1, strlen(s1));
  write(2, s2, strlen(s2));
  write(2, " : ", 3);
  s = error_message(errno);
  write(2, s, strlen(s));
  write(2, "\n", 1);
  exit(2);
}

  
